#ifndef GRAPH_H
#define GRAPH_H


//! \brief Structure
/*!
This is the structure that is used to communicate between the GUI frontend and 
backend. This structure is repopulated and filled in with current round data 
everytime a turn has passed in order to update the graph data on the frontend 
for all graphs
*********************************************************************************************/
struct pass_graph {

	/*! \brief numWinBars
    * The number of bars that won
    */
	int numWinBars; 
	
	/*! \brief numWinners
    * The number of Agents that won the current round
    */
	int numWinners; //
	
	/*! \brief avgStratScore
    * The average score of all Agent strategies
    */
	double avgStratScore; //
	
	/*! \brief bestStratScore
    * The score of the best faring Agent Strategy for the current round
    */
	double bestStratScore;
	
	/*! \brief  barCompare
    * Holds status of bars (i.e. won/lost)
    */
	bool barCompare[256];
	
	/*! \brief  age
    * Holds number of people of age of index.
    */
	bool age[100];

	/*! \brief  deaths
    * Holds how many people die per round.
    */
	bool deaths;
	};

	typedef struct pass_graph* graphPtr; 

#endif